(function() {
  'use strict';

  angular.module('weChatApp').factory('ChartJsPlugins', [factoryFn]);

  function factoryFn() {
    var plugins = this;

    function isPluginEnabled(chartInstance, pluginName) {
      return chartInstance.options[pluginName] && (typeof chartInstance.options[pluginName] === 'object' || typeof chartInstance.options[pluginName] === 'boolean');
    }

    plugins.centerLabel = {
      pluginName: 'centerLabel',

      beforeDraw: function(chart) {
        if(!isPluginEnabled(chart, this.pluginName)) {
          return;
        }

        if(chart.config.type === 'doughnut') {
          var width = chart.chart.width;
          var height = chart.chart.height;
          var ctx = chart.chart.ctx;

          ctx.restore();

          var fontSize = 1;
          ctx.font = "normal normal 100 "+ fontSize + "em 'Lato-Light'";
          ctx.textBaseline = "middle";

          if(chart.config.options[this.pluginName].text1Color) {
            ctx.fillStyle = chart.config.options[this.pluginName].text1Color;
          }

          var text = chart.config.options[this.pluginName].text1;
          var textX = Math.round((width - ctx.measureText(text).width) / 2);
          var textY = fontSize * 2 + height * 0.5;

          ctx.fillText(text, textX, textY);
          ctx.save();
        }
      }
    };

    return plugins;
  }
})();
